﻿Imports System.Xml.Linq
Imports System.IO
Imports System.Windows.Documents
Imports System.Windows.Input
Imports System.Windows.Media
Imports System.Windows.Media.Animation
Imports System.Windows.Shapes
Imports Microsoft.Phone.Controls

Imports Microsoft.Phone.Tasks
Public Class personalInfo
    Property 氏名 As String
    Property 電話 As String
End Class

Partial Public Class MainPage
    Inherits PhoneApplicationPage

    Dim myDoc As XElement
    Dim readXml As XElement

    ' Constructor
    Public Sub New()
        InitializeComponent()

        ' Set the data context of the listbox control to the sample data
        DataContext = App.ViewModel
    End Sub

    ' Load data for the ViewModel Items
    Private Sub MainPage_Loaded(ByVal sender As Object, ByVal e As RoutedEventArgs) Handles Me.Loaded
        DownloadXmlData()
    End Sub

    Private Sub okButton_Click(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles okButton.Click

        ErrorMessage()
        Dim myWebClient As New WebClient

        AddHandler myWebClient.DownloadStringCompleted, Sub(resultSender As Object, resultArgs As DownloadStringCompletedEventArgs)
                                                            If resultArgs.Error Is Nothing = False Then
                                                                MessageBox.Show("XMLファイルが見つかりません")
                                                                Exit Sub
                                                            Else
                                                                myDoc = XElement.Parse(resultArgs.Result)

                                                                readXml = New XElement("情報",
                                                                                         New XElement("氏名", nameTextBox.Text),
                                                                                         New XElement("電話", telTextBox.Text))
                                                                myDoc.Add(readXml)

                                                            End If
                                                        End Sub
        myWebClient.DownloadStringAsync(New Uri(String.Format("サーバーのURI/Telephone_NET/SaveData/personalInfo.xml?myTime={0}", DateTime.Now.ToLongTimeString), UriKind.Absolute))


    End Sub

    Private Sub saveButton_Click(sender As Object, e As System.Windows.RoutedEventArgs) Handles saveButton.Click

        ErrorMessage()

            Dim saveXmlData As String
            saveXmlData = myDoc.ToString
            'MessageBox.Show(saveXmlData)
            Dim myWebClient As New WebClient
            With myWebClient
                .Encoding = System.Text.Encoding.UTF8
                .Headers("content-type") = "text/xml; charset=utf-8"
            End With

            AddHandler myWebClient.UploadStringCompleted, Sub(resultSender As Object, resultArgs As UploadStringCompletedEventArgs)
                                                              'MessageBox.Show(resultArgs.Result)
                                                              MessageBox.Show("保存しました")
                                                              DownloadXmlData()

                                                          End Sub
        myWebClient.UploadStringAsync(New Uri(String.Format("サーバーのURI/Telephone_NET/Default.aspx?myTime={0}", DateTime.Now.ToLongTimeString), UriKind.Absolute), saveXmlData)



            nameTextBox.Text = String.Empty
            telTextBox.Text = String.Empty
            okButton.IsEnabled = True
        saveButton.IsEnabled = False

    End Sub


    Private Sub DownloadXmlData()
        Dim myWebClient2 As New WebClient
        AddHandler myWebClient2.DownloadStringCompleted, Sub(resultSender2 As Object, resultArgs2 As DownloadStringCompletedEventArgs)
                                                             If resultArgs2.Error Is Nothing = False Then
                                                                 MessageBox.Show("XMLファイルが見つかりません")
                                                                 Exit Sub
                                                             Else
                                                                 Dim myDoc As XElement = XElement.Parse(resultArgs2.Result)
                                                                 Dim myPersonalInfo As New List(Of personalInfo)
                                                                 For Each result In From c In myDoc.Descendants("情報") Select c
                                                                     With myPersonalInfo
                                                                         .Add(New personalInfo With {.氏名 = result.Element("氏名").Value,
                                                                                                    .電話 = result.Element("電話").Value})
                                                                     End With
                                                                 Next
                                                                 dataListBox.ItemsSource = myPersonalInfo
                                                             End If
                                                         End Sub
        myWebClient2.DownloadStringAsync(New Uri(String.Format("サーバーのURI/Telephone_NET/SaveData/personalInfo.xml?myTime={0}", DateTime.Now.ToLongTimeString), UriKind.Absolute))
    End Sub

    Private Sub dataListBox_SelectionChanged(sender As Object, e As System.Windows.Controls.SelectionChangedEventArgs) Handles dataListBox.SelectionChanged
        Dim phoneTask As New PhoneCallTask
        Dim telNumber As String = DirectCast(dataListBox.SelectedItem, personalInfo).電話
        With phoneTask
            .DisplayName = telNumber & "に電話します。"
            .PhoneNumber = telNumber
            .Show()
        End With
    End Sub

    Private Sub ErrorMessage()
        If nameTextBox.Text = String.Empty AndAlso telTextBox.Text = String.Empty Then
            MessageBox.Show("データを入力してください。")
            saveButton.IsEnabled = False
            Exit Sub
        Else
            saveButton.IsEnabled = True
        End If
    End Sub
End Class
